Subject: Re: FVWM: 300+MB for fwvm?

From: [email-masked]
Date: Thu, 19 Jun 2003 23:58:43 +0200

On Sun, Jul 14, 2002 at 03:12:42PM -0500, David Fries wrote:
> I can say for sure that fvwm 2.4.7 is leaking memory per program
> window.  I don't think the cvs version 2.5.3 is leaking, but I can't
> be completely sure.  I just ran a bunch of xterms and it seemed fine.
> 
> I've included a program to ponder, and I'll suggest using Xnest if
> anyone wants to run it, or an X session they don't want to use for a
> while.
> 
>   PID USER     PRI  NI  SIZE SWAP  RSS SHARE STAT %CPU %MEM   TIME COMMAND
> 23686 david      9   0   856  240  616   616 S     0.0  0.1   0:00 FvwmPager
> 23677 david      9   0   488  112  376   376 S     0.0  0.1   0:00 FvwmTheme
> 23653 david      9   0  321M 310M  10M 11060 S     0.0  3.5   2:49 fvwm
> 
> The program is simple enough, but here's what it does anyway.
> 1. open X connection
> 2. create window
> 3. destroy window
> 4. go to #2 n times (I'm using 1000000)
> 5. close X connection 
> 
> I'm just throwing this program out for anyone to look at if they are
> interested, I'm not going to look into it myself.  I tried it against
> kde maybe I didn't wait long enough (over night) but kde didn't
> recover where fvwm fully recovers, although it doesn't give the memory
> back to Linux.

Yes, I know I should have answered yopur mail a long time ago.  I
did not ignore it, but simply did not know what to do about it,
although I have tried many things.

The problem is that fvwm can not read the incoming events off the
Xlib input queue fast enough.  I tried various other window
managers and they all show the same behaviour.  Some manage to
mysteriously empty their input queue even under heavy fire by new
windows.  It is not clear to me why fvwm does not get enough CPU
to clkean out the queue while other WMs do.  My only guess is that
fvwm is too fast and becomes a victim of the X scheduler.

> On Thu, Jul 11, 2002 at 08:47:37AM +0200, Olivier Chapuis wrote:
> > On Tue, Jul 09, 2002 at 12:51:01AM -0500, David Fries wrote:
> > > Speaking of memory usage, has anyone thought about looking for some
> > > memory leaks?  Ok so I've been a lazy Debian user and I'm not up to
> > > what's in CVS (2.4.7 right now), but here's what I'm seeing (from top).
> > > 
> > >   PID USER     PRI  NI  SIZE SWAP  RSS SHARE STAT %CPU %MEM   TIME COMMAND
> > >   668 david      8   0 15300 8948 6352  3440 S     0.0  1.9   3:35 fvwm2
> > > after restarting fvwm, same windows etc
> > >   668 david     10   0  2468    0 2468  1348 S     0.1  0.7   3:36 fvwm2
> > >
> > 
> > Maybe some part the leaks come from the Xlib. I think that the
> > debian package is compiled with --enable-multibyte. There is some memory
> > leaks in XCreateFontSet: each time a font is unloaded ~4kb is lost (this
> > depends on the font, with an utf8 locale and if you use an iso106464-1
> > font with a big coverage this may be a lot more).
> > 
> > For example:
> > - if you delete a window ~4kb is lost (0kb with 2.5.2) 
> > - if you change your font and you have 20 windows, ~80kb is
> > lost (only 4kb with 2.5.2).
> > 
> > I've recently sent a patch to the XFree developers but no feedback yet ...
> > 
> > Note that I do not claim that all the leak come from the Xlib,
> > it is just a possibility. So one question and one query:
> > - Do you do something special regarding the fvwm config
> > (as regularly changing some config parameters)
> > - Can you send me your config file(s) if this is possible.

Bye

Dominik ^_^  ^_^

 --
Dominik Vogt, [email-masked]
Reply-To: [email-masked]
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].